Subject: Re: [RFC PATCH] prefix_path: show gitdir when arg is outside repo

From: Emily Shaffer <[email-masked]>
Date: Fri, 14 Feb 2020 16:46:06 -0800

On Sat, Feb 15, 2020 at 12:02:30AM +0000, brian m. carlson wrote:
> On 2020-02-14 at 23:29:33, [email-masked] wrote:
> > From: Emily Shaffer <[email-masked]>
> > 
> > When developing a script, it can be painful to understand why Git thinks
> > something is outside the current repo, if the current repo isn't what
> > the user thinks it is. Since this can be tricky to diagnose, especially
> > in cases like submodules or nested worktrees, let's give the user a hint
> > about which repository is offended about that path.
> > 
> > Signed-off-by: Emily Shaffer <[email-masked]>
> > ---
> > This one comes from a user feature request. This user is running some
> > Git client commands on a build machine somewhere and finding it hard to
> > reason about the cause of the "outside repo" error.
> > 
> > I see two arguments:
> > 
> > For:
> >  - A user checking their own `pwd` might still not come to the same
> >    conclusion Git does about the current repo, if their filesystem is in
> >    some weird state
> >  - This warning is intended for human eyes (die(), stderr) so it's reasonable
> >    to give some info to make the human's life easier
> > 
> > Against:
> >  - It's chatty, especially given the absolute directory. This may be a
> >    pretty common mistake ('git add' with thumbfingers?) so it could be
> >    chatty, frequently - not great.
> >    (Sidebar: Just including the relative directory is really not very
> >    useful - since you're still left thinking, "relative to where?")
> 
> I'm very much in favor of this patch.  I recently ran into a similar
> problem with Git LFS with path canonicalization and having both paths in
> the error message made it immediately obvious what the problem was.
> 
> > diff --git a/pathspec.c b/pathspec.c
> > index 128f27fcb7..5d661df5cf 100644
> > --- a/pathspec.c
> > +++ b/pathspec.c
> > @@ -439,7 +439,8 @@ static void init_pathspec_item(struct pathspec_item *item, unsigned flags,
> >  		match = prefix_path_gently(prefix, prefixlen,
> >  					   &prefixlen, copyfrom);
> >  		if (!match)
> > -			die(_("%s: '%s' is outside repository"), elt, copyfrom);
> > +			die(_("%s: '%s' is outside repository at '%s'"), elt,
> > +			    copyfrom, absolute_path(get_git_dir()));
> 
> Do we want the top level directory in these two spots instead of the git
> directory?  I suspect that might be more helpful, since it looks like
> we're dealing with working tree files.

I had considered it, and thought .git directory was less ambiguous,
primarily for the first bullet in the "For" list above - "for some
reason, the .git dir I see isn't the one that Git is coming up with".
The .git dir does have a pointer to the worktree ('gitdir' in the
worktree case and 'config' in the submodule case). Conversely, in both
the submodule and worktree cases the worktree contains a ".git" file
with the path to the gitdir.

I also tried the following:

  $ git clone --separate-git-dir=explicit-gitdir https://github.com/git/git
  explicit-worktree
  $ cd explicit-gitdir
  $ grep -Rn "explicit-worktree"
  <no results>
  $ cd ../explicit-worktree
  $ cat .git
  <absolute path to explicit-gitdir>

So it looks like in the clone with --separate-git-dir case, there's no
way to identify the worktree from the gitdir.

All this to say, on second thought, I think you're right. From the
worktree's top level, the gitdir is consistently findable. From gitdir,
the worktree is not consistently findable.

I'll send a reroll.

 - Emily

> -- 
> brian m. carlson: Houston, Texas, US
> OpenPGP: https://keybase.io/bk2204